signature OPENSEM =
sig
    structure B : AGENT
    structure D : DISTINCTION

    datatype commitment = Comm of B.T.test * B.Act.action * B.agent

    val c_mkstr : commitment -> string
    val cw_mkstr : commitment -> string
    val c_makstr : commitment * (string list) -> string
    val cw_makstr : commitment * (string list) -> string

    val commitments : B.agent * B.agent B.E.env -> commitment list

    val bisimilar : B.agent * B.agent * B.agent B.E.env * D.distinction -> bool
    val bisimulation : B.agent * B.agent * B.agent B.E.env * D.distinction -> (B.agent * B.agent * D.distinction) list

    val tauclose : B.agent * B.agent B.E.env -> commitment list
    val weakcomm : B.agent * B.agent B.E.env -> commitment list
    val cleartbls : unit -> unit
    val desctbls : unit -> unit
    val enabletbls : bool -> unit
    val enabledtbls : unit -> bool

    val weakbisimilar : B.agent * B.agent * B.agent B.E.env * D.distinction -> bool
    val weakbisimulation : B.agent * B.agent * B.agent B.E.env * D.distinction -> (B.agent * B.agent * D.distinction) list
end
	
